# Init ----------------------------------------------------------------------------------------

voorspel_instroom_ic_kl = function(voorspelde_opnames, df_nieuwe_opnames, ziekenhuis, voorspeldatum){
  nieuwe_opnames = voorspelde_opnames
  preds <- nieuwe_opnames %>%
    filter(datum > voorspeldatum) %>%
    select(-obs, -nieuwe_opn, -fit, -lwr, -upr)
  
  # schatting aantal IC --------------------------------------------------------------
  
  # Bereken perc_ic: Percentage dat bij binnenkomst direct naar de IC gaat (dus excl. latere
  # doorstroom vanuit kliniek)
  
  waarde_opname = 'direct'

    perc_ic <- sum(df_nieuwe_opnames$aantal_ic) / sum(df_nieuwe_opnames$aantal)
  
  
  # voorspelling opnames splitsen in aantal IC en KL --------------------------------------------------------------
  
  preds_opnames_ic <- preds %>%
    mutate_at(vars(-datum), ~ perc_ic * .x)
  
  preds_opnames_kl <- preds %>%
    mutate_at(vars(-datum), ~ (1 - perc_ic) * .x)
  
  nieuwe_opnames_ic <- df_nieuwe_opnames %>%
    select(datum, aantal_ic) %>%
    rename(opnames = aantal_ic) %>%
    merge(y = preds_opnames_ic, by = "datum", all = TRUE)
  
  nieuwe_opnames_kl <- df_nieuwe_opnames %>%
    select(datum, aantal_kliniek) %>%
    rename(opnames = aantal_kliniek) %>%
    merge(y = preds_opnames_kl, by = "datum", all = TRUE)
  


  return(mget(c('nieuwe_opnames_ic', 'preds_opnames_ic', 'nieuwe_opnames_kl', 'preds_opnames_kl')))

}