
voorspel_bezetting_huidig = function(ziekenhuis, ICset, Kliniekset, condprobs_kl, condprobs_ic, laatste_datum_opnamebestand, aantal_dagen, overplaatsingen_er_uit = F){
  # Lees data -----------------------------------------------------------------------
  
  #als overgeplaatste pat (vanuit andere zkh) er uit moeten, haal die patiënten dan van de bezetting af
  if(overplaatsingen_er_uit){
    list2env(haal_paden_overplaatsingen_er_uit(Kliniekset, ICset), envir = environment())
  }
  df_kl = Kliniekset
  df_ic = ICset
  
  waarde_aanwezig_kl <- "Kliniek - Nog opgenomen"
  waarde_aanwezig_ic <- "IC - Nog opgenomen"
  
  opgenomen_kl <- filter(df_kl, df_kl$vertrek_type == waarde_aanwezig_kl) %>%
    group_by(ligduur) %>%
    summarise(n(), .groups = "drop_last") %>%
    rename(aantal = `n()`)
  
  opgenomen_ic <- filter(df_ic, df_ic$vertrek_type == waarde_aanwezig_ic) %>%
    group_by(ligduur) %>%
    summarise(n(), .groups = "drop_last") %>%
    rename(aantal = `n()`)
  
  # Maak condprobs en pat_per_ld ----------------------------------------------------
  
  condprobs_kl$est <- voeg_kolommen_condprobs_toe(condprobs_kl$est, opgenomen_kl)
  pat_per_ld_kl <- bereken_pat_per_ld(opgenomen_kl, condprobs_kl$est)
  
  condprobs_ic$est <- voeg_kolommen_condprobs_toe(condprobs_ic$est, opgenomen_ic)
  pat_per_ld_ic <- bereken_pat_per_ld(opgenomen_ic, condprobs_ic$est)
  
  # Bezetting huidige patienten kliniek ------------------------------------------------------------------------
  
  # Vermenivuldig conditionele kansen met aantal patiënten per ligduur
  # Dit doen we door de kolommen van de conditionele kansen per ligduur te
  # vermenigvuldigen met het aantal patiënten per ligduur
  
  df <- map2_dfc(
    select(condprobs_kl$est, -aantal_dagen_vooruit),
    pat_per_ld_kl,
    ~ .x * .y
  )
  
  # Voeg verwachte bezetting toe aan huidige bezetting
  verwachte_bezetting_huidig_kl <- bind_rows(pat_per_ld_kl, df) %>%
    replace(is.na(.), 0) %>%
    mutate(som = rowSums(.))
  
  # Voeg de datums toe
  startdatum <- laatste_datum_opnamebestand
  verwachte_bezetting_huidig_kl$datum <-
    startdatum + days(0:(nrow(verwachte_bezetting_huidig_kl) - 1))
  
  verwachte_bezetting_huidig_kl <- verwachte_bezetting_huidig_kl %>%
    select(datum, som, everything())
  
  # Bezetting huidige patienten IC -----------------------------------------------------------------------------
  
  # Vermenivuldig conditionele kansen met aantal patiënten per ligduur
  df <- map2_dfc(
    select(condprobs_ic$est, -aantal_dagen_vooruit),
    pat_per_ld_ic,
    ~ .x * .y
  )
  
  # Voeg verwachte bezetting toe aan huidige bezetting. De eerste rij is de bezetting van
  # gisteren, de tweede rij de voorspelling voor morgen.
  verwachte_bezetting_huidig_ic <- bind_rows(pat_per_ld_ic, df) %>%
    replace(is.na(.), 0) %>%
    mutate(som = rowSums(.))
  
  # Voeg de datums toe
  startdatum <- laatste_datum_opnamebestand
  verwachte_bezetting_huidig_ic$datum <-
    startdatum + days(0:(nrow(verwachte_bezetting_huidig_ic) - 1))
  
  verwachte_bezetting_huidig_ic <- verwachte_bezetting_huidig_ic %>%
    select(datum, som, everything())
return(mget(c('verwachte_bezetting_huidig_ic', 'verwachte_bezetting_huidig_kl', 'pat_per_ld_ic', 'pat_per_ld_kl')))

}