# Lees data -----------------------------------------------------------------------------------

voorspel_doorstroom_huidig = function(df_kl, df_ic, condprobs_kl_ic, condprobs_ic_kl, laatste_datum_opnamebestand, aantal_dagen, overplaatsingen_er_uit = F){
  
  #als overgeplaatste pat (vanuit andere zkh) er uit moeten, haal die patiënten dan van de bezetting af
  if(overplaatsingen_er_uit){
    res = haal_paden_overplaatsingen_er_uit(df_kl, df_ic)
    df_kl = res[[1]]
    df_ic = res[[2]]
  }
  
  waarde_aanwezig_kl <- "Kliniek - Nog opgenomen"
  waarde_aanwezig_ic <- "IC - Nog opgenomen"

  
  opgenomen_kl <- filter(df_kl, df_kl$vertrek_type == waarde_aanwezig_kl) %>%
    group_by(ligduur) %>%
    summarise(n(), .groups = "drop_last") %>%
    rename(aantal = `n()`)
  
  opgenomen_ic <- filter(df_ic, df_ic$vertrek_type == waarde_aanwezig_ic) %>%
    group_by(ligduur) %>%
    summarise(n(), .groups = "drop_last") %>%
    rename(aantal = `n()`)
  
  # Maak condprobs en pat_per_ld ----------------------------------------------------
  
  condprobs_kl_ic$est <- voeg_kolommen_condprobs_toe(condprobs_kl_ic$est, opgenomen_kl)
  pat_per_ld_kl <- bereken_pat_per_ld(opgenomen_kl, condprobs_kl_ic$est)
  
  condprobs_ic_kl$est <- voeg_kolommen_condprobs_toe(condprobs_ic_kl$est, opgenomen_ic)
  pat_per_ld_ic <- bereken_pat_per_ld(opgenomen_ic, condprobs_ic_kl$est)
  
  # Verwachte doorstroom huidige kliniek patiënten naar IC ---------------------------------------
  
  doorstroom_kl_ic_huidig_cum <- map2_dfc(
    select(condprobs_kl_ic$est, -aantal_dagen_vooruit),
    pat_per_ld_kl,
    ~ .x * .y
  ) %>%
    replace(., is.na(.), 0) %>%
    mutate(som = rowSums(.))
  
  # Voeg de datums toe
  doorstroom_kl_ic_huidig_cum$datum <-
    laatste_datum_opnamebestand + days(1) +
    days(0:(nrow(doorstroom_kl_ic_huidig_cum) - 1))
  
  # Verwachte doorstroom huidige IC patiënten naar kliniek ---------------------------------------
  
  doorstroom_ic_kl_huidig_cum <- map2_dfc(
    select(condprobs_ic_kl$est, -aantal_dagen_vooruit),
    pat_per_ld_ic,
    ~ .x * .y
  ) %>%
    replace(., is.na(.), 0) %>%
    mutate(som = rowSums(.))
  
  # Voeg de datums toe
  doorstroom_ic_kl_huidig_cum$datum <-
    laatste_datum_opnamebestand + days(1) +
    days(0:(nrow(doorstroom_ic_kl_huidig_cum) - 1))
  
  # Verwachte doorstroom per dag komende 7 dagen kliniek IC bepalen ---------------------------------------
  
  # TODO Klopt het dat we de niet-cumulatieve versie nodig hebben?
  doorstroom_kl_ic_huidig <- doorstroom_kl_ic_huidig_cum %>%
    mutate(doorstroom_huidig = som - lag(som, default = 0)) %>%
    select(datum, doorstroom_huidig, som) %>%
    slice(1:aantal_dagen)
  
  # Verwachte doorstroom per dag komende 7 dagen ic naar kliniek bepalen ---------------------------------------
  
  doorstroom_ic_kl_huidig <- doorstroom_ic_kl_huidig_cum %>%
    mutate(doorstroom_huidig = som - lag(som, default = 0)) %>%
    select(datum, doorstroom_huidig) %>%
    slice(1:aantal_dagen)
  
  
  return(mget(c('doorstroom_ic_kl_huidig', 'doorstroom_kl_ic_huidig', 'condprobs_kl_ic', 'condprobs_ic_kl')))
}