
fn_voorspel_bezetting_toekomst = function(doorstroom_kl_ic_toekomst,doorstroom_ic_kl_toekomst, preds_opnames_ic, preds_opnames_kl, condprobs_kl, condprobs_ic,
                                          doorstroom_kl_ic_huidig, doorstroom_ic_kl_huidig, aantal_dagen){
  
  # Tel voorspelde doorstroom van huidig op bij voorspelde doorstroom van toekomst
  doorstroom_tot_ic <- doorstroom_kl_ic_toekomst %>%
    mutate_at(vars(-datum), ~ .x + doorstroom_kl_ic_huidig$doorstroom_huidig)
  
  # Bereken instroom: opnames + doorstroom
  som_data_frames_met_datum <- function(df1, df2) {
    df1 %>% 
      select(-datum) %>% 
      names() %>% 
      map_dfc(
        ~ select(df1, .x) + select(df2, .x)
      ) %>% 
      mutate(datum = pull(df1, datum)) %>% 
      select(datum, everything()) %>% 
      as_tibble()
  }
  
  # Tel doorstroom huidig en doorstroom toekomstig op bij instroom
  preds_instroom_ic <- som_data_frames_met_datum(preds_opnames_ic, doorstroom_tot_ic)
  
  # Bereken totale instroom kliniek -------------------------------------------------
  
  # Tel voorspelde doorstroom van huidig op bij voorspelde doorstroom van toekomst
  doorstroom_tot_kl <- doorstroom_ic_kl_toekomst %>%
    mutate_at(vars(-datum), ~ .x + doorstroom_ic_kl_huidig$doorstroom_huidig)
  
  # Tel doorstroom huidig en doorstroom toekomstig op bij instroom
  preds_instroom_kl <- som_data_frames_met_datum(preds_opnames_kl, doorstroom_tot_kl)
  
  # Voorspel bezetting toekomst kliniek ---------------------------------------------------------
  
  # Voor alle toekomstige patiënten, wanneer stromen ze uit?
  # TODO Aanpassen aan nieuwe methode
  preds_bezet_toekomst_kl <- condprobs_kl$est %>%
    select(aantal_dagen_vooruit, ligduur_01) %>%
    filter(aantal_dagen_vooruit <= aantal_dagen) %>%
    voorspel_bezetting_toekomst(preds_instroom_kl, ., aantal_dagen )
  
  # preds_kl <- preds_kl %>%
  # left_join(preds_toekomst_kl, by = "datum")
  
  # Voorspel bezetting toekomst IC ---------------------------------------------------------
  
  # Voor alle toekomstige patiënten, wanneer stromen ze uit?
  preds_bezet_toekomst_ic <- condprobs_ic$est %>%
    select(aantal_dagen_vooruit, ligduur_01) %>%
    filter(aantal_dagen_vooruit <= aantal_dagen) %>%
    voorspel_bezetting_toekomst(preds_instroom_ic, ., aantal_dagen )
  
  return(mget(c('preds_bezet_toekomst_ic', 'preds_bezet_toekomst_kl')))
}
