rm(list=ls())
Sys.setlocale("LC_ALL", "English")
source('R/utils.R')
source('R/00_maak_datasets.R')
require(reshape2)
require(tibbletime)
library(xtable)
library(scales)
library(tables)
source('R/data analyse/maak_plots_voorspellingen.R')

# scenarios = c('log')
# ziekenhuis <- "LUMC"
# aantal_dagen <- 5 #maximale horizon
# overplaatsingen_er_uit = T
# dept = 'IC'
# 
# load( paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),aantal_dagen, '_pred.Rds'))
# data_pred = summaries
# load(  paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),aantal_dagen,'.Rds'))
# data_sim = summaries
# 
# for(hor in seq(aantal_dagen)){
#   pred_det = c()
#   pred_sim = c()
#   for(i in seq(length(data_pred))){
#     if(strcmp(dept, 'IC')){
#       pred_det = c(pred_det, data_pred[[i]]$preds_bezet_tot_ic$log[hor+1])
#       pred_sim = c(pred_sim, data_sim[[i]]$pred_df_ic$avg_log[hor+1])
#     }else{
#       pred_det = c(pred_det, data_pred[[i]]$preds_bezet_tot_kl$log[hor+1])
#       pred_sim = c(pred_sim, data_sim[[i]]$pred_df_kl$avg_log[hor+1])
#     }
#   }
#   plot( pred_det, type = 'l', ylim = c(min(c(pred_det, pred_sim)), max(c(pred_det, pred_sim))), col = 'red', xlab = 'index prediction point', ylab = 'predicted occupancy')
#   lines( pred_sim)
#   title(paste0('horizon = ', hor, ', rood = deterministisch, zwart = simulatie'))}

if(sys.nframe() == 0){
  # hier stel je param in voor plots, eerst moet "haal_voorspellingen_op.R" met deze parameters gedraaid worden en er moet dan een .rds file weggeschreven zijn met deze parameter instellingen
  ziekenhuis = 'Haga'
  scenarios = c('log')
  horizons = ifelse(strcmp(ziekenhuis, 'LUMC'), c(1,2,3,5), c(1,3))
  horizon_CI_plot = 3
  bool_save = T
  horizon_max = 3
  aantal_dagen = 5
  overplaatsingen_er_uit = T
  TOT_tot_df = NULL
  tot_pred_kl = NULL
  tot_pred_ic = NULL
  num_tbl = 10

  #obtain data
  source('R/00_maak_datasets.R')
  list2env(maak_datasets(ziekenhuis), envir = .GlobalEnv)

  #obtain error tables per simulation runs and append
  for(i in seq(1,num_tbl)){
    print(i)
    load(paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),aantal_dagen,'_',i,'.Rds'))
    
    #maak plots en haal foutentabel op voor sim voorspeller
    res_dag = maak_plots_voorspellingen_sim_EN(summaries, Kliniekset, ICset, scenarios, c(1,2,3,5), overplaatsingen_er_uit, CI_plot = F, save_plots = F)
    if(i==2){# dataset 2 has old structure in this experiment, remove this if-statement if we do a new experiment!
      load(paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),horizon_max,'.Rds'))
      res_max = maak_plots_maxima_oud(summaries, Kliniekset, ICset, horizon_max, overplaatsingen_er_uit, taal = 'EN' , save_plots = F)}else{
      res_max =maak_plots_maxima(summaries, Kliniekset, ICset, horizon_max, overplaatsingen_er_uit, taal = 'EN' , save_plots = T)}
    
    tot_df_eval = full_join(res_dag$tot_eval, res_max) 

    if(is.null(TOT_tot_df)){
      TOT_tot_df = tot_df_eval
      tot_pred_ic = res_dag$df_pred_plot_ic
      tot_pred_kl = res_dag$df_pred_plot_kl
    }else{
      TOT_tot_df = TOT_tot_df %>% left_join(tot_df_eval, by = c('dept', 'type', 'name'))
      tot_pred_ic = tot_pred_ic %>% left_join(res_dag$df_pred_plot_ic, by = c('date','variable'))
      tot_pred_kl = tot_pred_kl %>% left_join(res_dag$df_pred_plot_kl, by = c('date','variable'))
    }
  }
  maak_plots_voorspellingen_sim_EN(summaries, Kliniekset, ICset, scenarios,horizon_CI_plot  ,overplaatsingen_er_uit , CI_plot = T, save_plots = T)
  maak_plots_voorspellingen_sim_EN(summaries, Kliniekset, ICset, scenarios, horizons, overplaatsingen_er_uit, CI_plot = F, save_plots = T)
  
  #generate error results table
  avg_tot_df = TOT_tot_df %>% select(dept, type, name) %>% mutate(value = apply( TOT_tot_df %>% select(-dept, -type, -name), 1, mean))
  res_forecaster = avg_tot_df %>% add_column(method = 'Forecast') %>% mutate(value = round(value,2))
  res_ma = res_dag$tot_eval_ma %>% full_join( res_max %>% mutate(value = NULL)) %>% add_column(method = 'Mov.av.forecaster')
  tot_df_eval = full_join(res_forecaster, res_ma)
  results_table <- tabular(RowFactor(type, name = 'type') ~
                             Heading()*Factor(method, levelnames = c('Forecast', 'Mov.av.forecaster'))*Heading()*Factor(dept,
                                                                                                                        levelnames =  c("ICU",
                                                                                                                                        "Ward" ))*
                             Heading()*Factor(name,
                                              levelnames = c('bias', 'CR', 'MAE' ))*Heading()*(value)*Heading()*(mean)*
                             DropEmpty(empty=""),
                           data = tot_df_eval)
  results_table = results_table[,-c(8,11)]
  results_table[is.na(results_table)] = '-'
  results_table= results_table[,c(2,1,3,5,4,6,7,8,9,10)]
  
  #get standard deviations of table values over simulation runs
  sd_tot_df = TOT_tot_df %>% select(dept, type, name) %>% mutate(value = apply( TOT_tot_df %>% select(-dept, -type, -name), 1, function(v){round(sd(v),2)}))
  results_table_sd <- tabular(RowFactor(type, name = 'type') ~
                             Heading()*Factor(dept,
                                              levelnames =  c("ICU",
                                                              "Ward" ))*
                             Heading()*Factor(name,
                                              levelnames = c('bias', 'CR', 'MAE' ))*Heading()*(value)*Heading()*(mean)*
                             DropEmpty(empty=""),
                           data = sd_tot_df)
  
  
  
  mean_rdiff_forecast_ic = tot_pred_ic%>% select(date, variable) %>% mutate(value = apply( tot_pred_ic %>%
                                                                                     select(-date, -variable), 1, function(v){(max(v)-min(v))/mean(v)}))%>%
                                  group_by(variable)%>%summarise( value = mean(value, na.rm = T))%>%ungroup()
  
  mean_rdiff_forecast_kl = tot_pred_kl%>% select(date, variable) %>% mutate(value = apply( tot_pred_kl %>%
                                                                                     select(-date, -variable), 1, function(v){(max(v)-min(v))/mean(v)}))%>%
    group_by(variable)%>%summarise( value = mean(value, na.rm = T))%>%ungroup()
    
  max_rdiff_forecast_ic = tot_pred_ic%>% select(date, variable) %>% mutate(value = apply( tot_pred_ic %>%
                                                                                     select(-date, -variable), 1, function(v){(max(v)-min(v))/mean(v)}))%>%
                                  group_by(variable)%>%summarise( value = max(value, na.rm = T))%>%ungroup()
  
  max_rdiff_forecast_kl = tot_pred_kl%>% select(date, variable) %>% mutate(value = apply( tot_pred_kl %>%
                                                                                     select(-date, -variable), 1, function(v){(max(v)-min(v))/mean(v)}))%>%
    group_by(variable)%>%summarise( value = max(value, na.rm = T))%>%ungroup()
  

  if(bool_save){
  write(tables::latex.tabular(results_table)[[1]], file = paste0('R/data analyse/data/foutentabel_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen', '_overplaatsingen'),'_avg.tex'))
  }
}
