rm(list=ls())
library(tibbletime)
library(tibble)
library(dplyr)
library(tidyr)
source("R/utils.R") # basisfuncties + packages inladen
source('R/functies.R')
source('R/functies_condprobs.R')
source("R/00_maak_datasets.R", encoding = "UTF-8")
source('R/data analyse/maak_voorspellingen_pred.R')
source('R/data analyse/maak_voorspellingen_sim.R')
get_val_horizon =  function(DESres, horizon){
  rij_bezetting_horizon = DESres[DESres$date >= DESres$date[1] + days(horizon), ][1,]
  return(rij_bezetting_horizon)
}


if(sys.nframe() == 0){
  set.seed(as.numeric(Sys.time())) # seed is nu in ieder geval altijd anders (afhankelijk van de huidige datumtijd incl seconden)
  # tic()
  # voorspel rollend 2 weken vooruit op basis van de data beschikbaar op dat moment 
  # Kies ziekenhuis
  scenarios = c('log')
  ziekenhuis <- "rs"
  aantal_dagen <- 5 #maximale horizon
  overplaatsingen_er_uit = T
  sim =T
  
  naam_voluit = ifelse(ziekenhuis == 'etz', 'Elisabeth TweeSteden Ziekenhuis',
                ifelse(ziekenhuis == 'rs', 'Rijnstate', 'Ziekenhuis Onbekend'))
  
  
  if(ziekenhuis == 'rs'){
    start_date = as.Date('2020-03-30') #voor rs: 157 pat vertrokken, slechts 7 vanaf IC. 
  }else{
    if(ziekenhuis %in% c('etz', 'ETZ')){
      start_date = as.Date('2020-03-23') #104 pat vertrokken, 24 van IC
    }else{
      if(ziekenhuis == 'LUMC'){
        start_date = as.Date('2020-04-15') #129 pat vertrokken, 30 op IC
      }else{
        if(ziekenhuis == 'Haga'){
          start_date = as.Date('2020-03-30')
        }
      }
    }
  }
  increment = 1 #days
  
  # laad data in voor ziekenhuis
  list2env(maak_datasets(ziekenhuis), envir = .GlobalEnv)
  end_date = min(as.Date(datetime_pred), as.Date('2020-07-20')) #minimum van einddatum eerste golf en datum opnamebestand
  df_nieuwe_opnames = df_nieuwe_opnames[df_nieuwe_opnames$datum <= end_date,]
  Kliniekset        = maak_partiele_set(Kliniekset, end_date, name_dept = 'Kliniek', name_other_dept = 'IC') 
  ICset             = maak_partiele_set(ICset, end_date, name_dept = 'IC', name_other_dept = 'Kliniek')
  Kliniekset$BehandelBeperking = 'Geen behandelbeperking'
  ICset$BehandelBeperking = 'Geen behandelbeperking'
  
  date = start_date
  summaries = list()
  dates = c()
  while(date + days(aantal_dagen)<= end_date){
    print(date)
    dates                       = c(dates, toString(date + days(aantal_dagen)))
    df_nieuwe_opnames_partial   = df_nieuwe_opnames[df_nieuwe_opnames$datum <= date,]
    Kliniekset_partial          = maak_partiele_set(Kliniekset, date, name_dept = 'Kliniek', name_other_dept = 'IC')
    ICset_partial               = maak_partiele_set(ICset, date, name_dept = 'IC', name_other_dept = 'Kliniek')
    options(warn=-1)
    if(sim){
      summaries[[toString(date)]] = maak_voorspellingen_sim(Kliniekset_partial, ICset_partial , df_nieuwe_opnames_partial , ziekenhuis, aantal_dagen, scenarios, date, overplaatsingen_er_uit = overplaatsingen_er_uit)
    }else{
      summaries[[toString(date)]] = maak_voorspellingen_pred(Kliniekset_partial, ICset_partial, df_nieuwe_opnames_partial, ziekenhuis, aantal_dagen, scenarios, date, overplaatsingen_er_uit = overplaatsingen_er_uit )
    }
    options(warn=0)
    date = date + days(increment)
  }
  
  #sla file met voorspellingen op onder nieuwe naam
  app ='_1'
  num = 0
  name = paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),aantal_dagen,ifelse(sim, '', '_det'),app,'.Rds')
  while(file.exists(name)){
    num = num + 1
    app = paste0('_',num)
    name = paste0('R/data analyse/data/rolling_preds_',ziekenhuis,ifelse(overplaatsingen_er_uit,'_geen_overplaatsingen_hor=', '_overplaatsingen_hor='),aantal_dagen,ifelse(sim, '', '_det'),app,'.Rds')
  }
  save(summaries, file = name)
}


