rm(list=ls())
Sys.setlocale("LC_ALL", "English")
# Kies ziekenhuis
ziekenhuis <- "Haga"
start_tweede_golf = as.Date('2020-07-01') #start datum 2e golf (alle data daarvoor wordt NIET gebruikt voor schatten aankomstproces Richard's curve aangezien de dynamiek nu anders is)
naam_voluit = ifelse(ziekenhuis == 'etz', 'Elisabeth TweeSteden Ziekenhuis',
                     ifelse(ziekenhuis == 'rs', 'Rijnstate', 
                            ifelse(ziekenhuis == 'LUMC', 'LUMC', 
                                   ifelse(ziekenhuis == 'Haga', 'Haga','Onbekend'))))
scenarios = c('log')

# Laad packages en basisfuncties
source("R/utils.R") # basisfuncties + packages inladen
source("R/functies.R") # basisfuncties + packages inladen
source("R/functies_condprobs.R") #  basisfuncties + packages inladen

# laad functie om data in te lezen, evalueer op ziekenhuis
source("R/00_maak_datasets.R", encoding = "UTF-8")
list2env(maak_datasets(ziekenhuis), envir = .GlobalEnv)
laatste_datumtijd_opnamebestand <- as.POSIXct(datetime_pred, tz = 'UTC')
laatste_datum_opnamebestand <- as.Date(datetime_pred)
aantal_dagen = 14

# laad functies om aankomsten te voorspellen, evalueer op nieuwe opnames
source("R/01_voorspel_instroom.R", encoding = "UTF-8")
voorspelde_opnames = voorspel_instroom(df_nieuwe_opnames, aantal_dagen = aantal_dagen, scenarios, voorspeldatum = laatste_datum_opnamebestand, exclude_until = start_tweede_golf)

# laad functies om aankomsten te splitsen per afdeling, evalueer op voorspelde en geobserveerde opnames
source("R/02_voorspel_instroom_ic_kl.R", encoding = "UTF-8")
list2env(voorspel_instroom_ic_kl(voorspelde_opnames, df_nieuwe_opnames, ziekenhuis), envir = .GlobalEnv)

# laad functies survival analyse op ligduren, evalueer op ICset en Kliniekset
source("R/03_survival_analyse.R", encoding = "UTF-8")
list2env( survival_analyse(ziekenhuis, ICset, Kliniekset), envir= .GlobalEnv)

# laad functies voorspellen uitstroom huidige patiënten en evalueer
source("R/04_voorspel_bezetting_huidig.R", encoding = "UTF-8")
list2env(voorspel_bezetting_huidig(ziekenhuis, ICset, Kliniekset, condprobs_kl , condprobs_ic , laatste_datum_opnamebestand, aantal_dagen), envir = .GlobalEnv)

#laad functie om systeeminfo op te halen voor DES, evalueer
source('R/get_system_information.R', encoding = "UTF-8")
bez_met_overpl = get_system_information(Kliniekset, ICset, preds_opnames_ic, preds_opnames_kl, 
                                condprobs_ic, condprobs_kl, condprobs_ic_kl, condprobs_kl_ic, condprobs_kl_ic_gbhbp, laatste_datumtijd_opnamebestand ,overplaatsingen_er_uit = T )



bez_zonder_overpl = get_system_information(Kliniekset, ICset, preds_opnames_ic, preds_opnames_kl, 
                                        condprobs_ic, condprobs_kl, condprobs_ic_kl, condprobs_kl_ic, condprobs_kl_ic_gbhbp, laatste_datumtijd_opnamebestand ,overplaatsingen_er_uit = F)

tabel_bezetting_ic = tibble(datum = bez_met_overpl$hist_bezetting_ic$datum, 
                            `Bezetting zonder overplaatsingen` = bez_met_overpl$hist_bezetting_ic$bezetting,
                            `Bezetting met overplaatsingen` = bez_zonder_overpl$hist_bezetting_ic$bezetting) %>% filter(datum  >= start_tweede_golf)




tabel_bezetting_kl = tibble(datum = bez_met_overpl$hist_bezetting_kl$datum, 
                            `Bezetting zonder overplaatsingen` = bez_met_overpl$hist_bezetting_kl$bezetting,
                            `Bezetting met overplaatsingen` = bez_zonder_overpl$hist_bezetting_kl$bezetting) %>% filter(datum  >= start_tweede_golf)

ggplot(tabel_bezetting_ic, aes(x = datum)) + geom_line(aes(y = `Bezetting zonder overplaatsingen`), col = 'red') + geom_line(aes(y = `Bezetting met overplaatsingen`), col = 'purple')


