

maak_voorspellingen_sim = function(Kliniekset, ICset, df_nieuwe_opnames, ziekenhuis, aantal_dagen, scenarios, voorspeldatum, overplaatsingen_er_uit=F){
  
  laatste_datumtijd_opnamebestand <- max(df_nieuwe_opnames$datum)
  laatste_datum_opnamebestand <- max(df_nieuwe_opnames$datum)
  
  # laad functies om aankomsten te voorspellen, evalueer op nieuwe opnames
  source("R/01_voorspel_instroom.R", encoding = "UTF-8")
  voorspelde_opnames = voorspel_instroom(df_nieuwe_opnames, aantal_dagen = aantal_dagen, scenarios, voorspeldatum = laatste_datum_opnamebestand)
  
  # laad functies om aankomsten te splitsen per afdeling, evalueer op voorspelde en geobserveerde opnames
  source("R/02_voorspel_instroom_ic_kl.R", encoding = "UTF-8")
  list2env(voorspel_instroom_ic_kl(voorspelde_opnames, df_nieuwe_opnames, ziekenhuis, voorspeldatum = laatste_datum_opnamebestand), envir = environment())
  
  # laad functies survival analyse op ligduren, evalueer op ICset en Kliniekset
  source("R/03_survival_analyse.R", encoding = "UTF-8")
  list2env( survival_analyse(ziekenhuis, ICset, Kliniekset), envir= environment())
  
  # laad functies voorspellen uitstroom huidige patiënten en evalueer
  source("R/04_voorspel_bezetting_huidig.R", encoding = "UTF-8")
  list2env(voorspel_bezetting_huidig(ziekenhuis, ICset, Kliniekset, condprobs_kl , condprobs_ic , laatste_datum_opnamebestand, aantal_dagen, 
                                     overplaatsingen_er_uit = overplaatsingen_er_uit), envir = environment())
  
  #laad functie om systeeminfo op te halen voor DES, evalueer
  source('R/get_system_information.R', encoding = "UTF-8")
  list2env(get_system_information(Kliniekset, ICset, preds_opnames_ic, preds_opnames_kl, 
                                  condprobs_ic, condprobs_kl, condprobs_ic_kl, condprobs_kl_ic, condprobs_kl_ic_gbhbp, laatste_datumtijd_opnamebestand ,
                                  overplaatsingen_er_uit = overplaatsingen_er_uit), envir = environment())
  
  # draai DES
  source('R/DES.R')
  source('R/perform_simulation_study.R', encoding = "UTF-8")
  simresults = perform_simulation_study(laatste_datum_opnamebestand, aantal_dagen, list_scenario_arrival_rates, 
                                        departure_info, current_patient_info, patienttype_info, scenarios)
  
  # vat de simulatiestudie samen in een voorspelling van de gemiddelde en maximale benutting 
  source('R/summarise_simulations.R', encoding = "UTF-8")
  res = summarise_simulations(simresults, scenarios, aantal_dagen, voorspeldatum  = laatste_datum_opnamebestand, CI_val = 0.95, all_hor_max = T)
  

return(res)

}




