# 
# 
# summarise_simulations = function(simresults, preds_kl, scenarios ){
#   #bereken de voorspelde bezetting + 80%CI en ook de kwantielen van maximale bezetting per dag. 
#   
#   #obtain prediction times
#   pred_times = c(preds_kl$datum[1] - days(1), preds_kl$datum)
#   pred_times_num = as.numeric(c(0, row.names(preds_kl)))
#   CI_val = 0.8
#   
#   pred_df_ic = tibble(datum = pred_times)
#   pred_df_kl = tibble(datum = pred_times)  
#   maxima_IC = c()
#   maxima_kl = c()
#   for(scenario in scenarios){
#     simres = simresults[[scenario]]
#     M = length(simres)
#   
#     IC_per_day = c()
#     KL_per_day = c()
#     maxima_IC_scen = c()
#     maxima_kl_scen = c()
#     for(i in seq(M)){
#       sim = simres[[i]] %>% mutate(date = ceiling_date(date, unit = 'days')) %>% group_by(date) %>% summarise(Kliniek = last(Kliniek), IC = last(IC), .groups = 'drop') %>% ungroup()
#       jump_times = difftime(sim$date , pred_times[1] , unit = 'days')
#       
#       #num pat ic kl per day
#       IC_per_day = rbind(IC_per_day, approx(jump_times, sim$IC, pred_times_num, rule = 2)$y)
#       KL_per_day = rbind(KL_per_day, approx(jump_times, sim$Kliniek,pred_times_num, rule = 2)$y)
#       
#       #adding maxima over path to vector
#       maxima_IC_scen = c(maxima_IC_scen, max(sim$IC))
#       maxima_kl_scen = c(maxima_kl_scen, max(sim$Kliniek))
#     }
#     #obtaining average, upper and lower confidence bounds over simulations
#     pred_df_ic = pred_df_ic %>% mutate(   !!paste('lbCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(IC_per_day, 2, function(v){quantile(v, (1-CI_val)/2)}),
#                                           !!paste('avg_', scenario, sep = '') := apply(IC_per_day, 2, mean),
#                                           !!paste('ubCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(IC_per_day, 2, function(v){quantile(v, 1-(1-CI_val)/2)}))
#                                           
#     
#     pred_df_kl = pred_df_kl %>% mutate(!!paste('lbCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(KL_per_day, 2, function(v){quantile(v, (1-CI_val)/2)}),
#                                        !!paste('avg_', scenario, sep = '') := apply(KL_per_day, 2, mean),
#                                        !!paste('ubCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(KL_per_day, 2, function(v){quantile(v, 1-(1-CI_val)/2)}))
#     
#     maxima_IC = cbind(maxima_IC, maxima_IC_scen)
#     maxima_kl= cbind(maxima_kl, maxima_kl_scen)
#     
#   }
#   
#   colnames(maxima_IC ) = sapply(scenarios, function(scenario){names_cols[scenario]})
#   colnames(maxima_kl ) = colnames(maxima_IC )
# 
# 
# return(mget(c('pred_df_ic', 'pred_df_kl', 'maxima_IC', 'maxima_kl')))
# }

summarise_simulations = function(simresults, scenarios, aantal_dagen, voorspeldatum , CI_val = 0.8, all_hor_max = F){
  #bereken de voorspelde bezetting + 80%CI en ook de kwantielen van maximale bezetting per dag. 
  pred_times_num = seq(0, aantal_dagen)
  pred_datetimes = seq(voorspeldatum, voorspeldatum + days(aantal_dagen), by = 'days')
  pred_df_ic = tibble(datum = pred_datetimes)
  pred_df_kl = tibble(datum = pred_datetimes)
  if(all_hor_max){
    maxima_IC = list()
    maxima_kl = list()
  }else{
  maxima_IC = c()
  maxima_kl = c()}
  for(scenario in scenarios){
    bezetting_ic_scen = Reduce(cbind , lapply(simresults[[scenario]], function(tbl){tbl$IC}))
    bezetting_kl_scen = Reduce(cbind , lapply(simresults[[scenario]], function(tbl){tbl$Kliniek}))
    
    #obtaining average, upper and lower confidence bounds over simulations
    pred_df_ic = pred_df_ic %>% mutate(   !!paste('lbCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(bezetting_ic_scen, 1, function(v){quantile(v, (1-CI_val)/2)}),
                                          !!paste('avg_', scenario, sep = '') := apply(bezetting_ic_scen, 1, mean),
                                          !!paste('ubCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(bezetting_ic_scen, 1, function(v){quantile(v, 1-(1-CI_val)/2)}))
    
    
    pred_df_kl = pred_df_kl %>% mutate(!!paste('lbCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(bezetting_kl_scen, 1, function(v){quantile(v, (1-CI_val)/2)}),
                                       !!paste('avg_', scenario, sep = '') := apply(bezetting_kl_scen, 1, mean),
                                       !!paste('ubCI',toString(round(CI_val*100)),'%_', scenario, sep = '') := apply(bezetting_kl_scen, 1, function(v){quantile(v, 1-(1-CI_val)/2)}))
    

    
    if(all_hor_max){
      #bereken maximum bezetting, sla op in df
      maxima_IC[[scenario]] = sapply(simresults[[scenario]], function(tbl){cummax(tbl$IC)})
      maxima_kl[[scenario]] = sapply(simresults[[scenario]], function(tbl){cummax(tbl$Kliniek)})
    }else{
      #bereken maximum bezetting, sla op in df
      maxima_IC = cbind(maxima_IC, sapply(simresults[[scenario]], function(tbl){max(tbl$IC)}))
      maxima_kl= cbind(maxima_kl,  sapply(simresults[[scenario]], function(tbl){max(tbl$Kliniek)}))
    }
  }
  if(!all_hor_max){
  colnames(maxima_IC ) = sapply(scenarios, function(scenario){names_cols[scenario]})
  colnames(maxima_kl ) = colnames(maxima_IC )}
  
  return(mget(c('pred_df_ic', 'pred_df_kl', 'maxima_IC', 'maxima_kl')))
}



